/*******************************************************************************
 * Copyright (c) 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     Zend Technologies
 *******************************************************************************/
package org.eclipse.php.internal.ui;

/**
 * This code was generated using the HelpContextGenerator
 * (org.eclipse.php.help.util).
 */
public interface IPHPHelpContextIds {

	public static final String PREFIX = "org.eclipse.php.help."; //$NON-NLS-1$

	// Note: This interface is indented according to the TOC levels.
	// Do not format this code

	public static final String PDT_USER_GUIDE = PREFIX + "pdt_user_guide"; // [html/Welcome.htm] //$NON-NLS-1$
	public static final String GETTING_STARTED = PREFIX + "getting_started"; // [html/Getting_Started.htm] //$NON-NLS-1$
	public static final String QUICK_START = PREFIX + "quick_start"; // [html/Quick_Start.htm] //$NON-NLS-1$
	public static final String BASIC_TUTORIALS = PREFIX + "basic_tutorials"; // [html/Basic_Tutorial.htm] //$NON-NLS-1$
	public static final String CREATING_PROJECTS_AND_FILES = PREFIX
			+ "creating_projects_and_files"; // [html/Creating_and_Uploading_a_Project.htm] //$NON-NLS-1$
	public static final String WORKING_WITH_CODE_ASSIST = PREFIX
			+ "working_with_code_assist"; // [html/Working_with_Code_Assist.htm] //$NON-NLS-1$
	public static final String WORKING_WITH_THE_DEBUGGER = PREFIX
			+ "working_with_the_debugger"; // [html/Working_with_the_Debugger.htm] //$NON-NLS-1$
	public static final String CONCEPTS = PREFIX + "concepts"; // [html/Concepts.htm] //$NON-NLS-1$
	public static final String PHP_SUPPORT = PREFIX + "php_support"; // [html/PHP_Support.htm] //$NON-NLS-1$
	public static final String CODE_ASSIST = PREFIX + "code_assist"; // [html/Code_Assist_Concept.htm] //$NON-NLS-1$
	public static final String AUTOMATIC_COMPLETION = PREFIX
			+ "automatic_completion"; // [html/Automatic_Insertion.htm] //$NON-NLS-1$
	public static final String MATCHING_BRACKETS = PREFIX + "matching_brackets"; // [html/Matching_Brackets.htm] //$NON-NLS-1$
	public static final String CODE_FOLDING = PREFIX + "code_folding"; // [html/Code_Folding.htm] //$NON-NLS-1$
	public static final String SYNTAX_COLORING = PREFIX + "syntax_coloring"; // [html/Syntax_Highlighting.htm] //$NON-NLS-1$
	public static final String COMMENTING_CODE = PREFIX + "commenting_code"; // [html/Commenting_Code.htm] //$NON-NLS-1$
	public static final String PHPDOC_BLOCK_COMMENTS = PREFIX
			+ "phpdoc_block_comments"; // [html/phpDoc_Comments.htm] //$NON-NLS-1$
	public static final String HOVER_SUPPORT = PREFIX + "hover_support"; // [html/Hover_Support.htm] //$NON-NLS-1$
	public static final String PHP_MANUAL_INTEGRATION = PREFIX
			+ "php_manual_integration"; // [html/PHP_Manual_Integration.htm] //$NON-NLS-1$
	public static final String REAL_TIME_ERROR_DETECTION = PREFIX
			+ "real_time_error_detection"; // [html/Real_Time_Error_Detection.htm] //$NON-NLS-1$
	public static final String DEBUGGING = PREFIX + "debugging"; // [html/Debugging_Concept.htm] //$NON-NLS-1$
	public static final String PATH_MAPPING = PREFIX + "path_mapping"; // [html/Path_Mapping.htm] //$NON-NLS-1$
	public static final String INCLUDE_PATHS = PREFIX + "include_paths"; // [html/Include_Paths.htm] //$NON-NLS-1$
	public static final String TASKS = PREFIX + "tasks"; // [html/Tasks.htm] //$NON-NLS-1$
	public static final String EASY_FILE_CREATION = PREFIX
			+ "easy_file_creation"; // [html/File_Creation.htm] //$NON-NLS-1$
	public static final String CREATING_A_PHP_FILE_WITHIN_A_PROJECT = PREFIX
			+ "creating_a_php_file_within_a_project"; // [html/Creating_a_PHP_File_within_a_Project.htm] //$NON-NLS-1$
	public static final String OPENING_AN_EXTERNAL_FILE = PREFIX
			+ "opening_an_external_file"; // [html/Opening_an_External_File_in_Neon.htm] //$NON-NLS-1$
	public static final String USING_CODE_ASSIST = PREFIX + "using_code_assist"; // [html/Using_Code_Assist.htm] //$NON-NLS-1$
	public static final String USING_TEMPLATES = PREFIX + "using_templates"; // [html/Using_Templates.htm] //$NON-NLS-1$
	public static final String SEARCHING_FOR_PHP_ELEMENTS = PREFIX
			+ "searching_for_php_elements"; // [html/Searching_for_PHP_Elements.htm] //$NON-NLS-1$
	public static final String OPENING_PHP_ELEMENTS = PREFIX
			+ "opening_php_elements"; // [html/Opening_PHP_Elements.htm] //$NON-NLS-1$
	public static final String FORMATTING_CODE = PREFIX + "formatting_code"; // [html/Formatting_Code.htm] //$NON-NLS-1$
	public static final String USING_CODE_FOLDING = PREFIX
			+ "using_code_folding"; // [html/Using_Code_Folding.htm] //$NON-NLS-1$
	public static final String ADDING_COMMENTS = PREFIX + "adding_comments"; // [html/How_to_Comment_and_Uncomment_PHP_Code.htm] //$NON-NLS-1$
	public static final String ADDING_PHP_DOCBLOCK_COMMENTS = PREFIX
			+ "adding_php_docblock_comments"; // [html/Commenting_PHP_DocBlocks.htm] //$NON-NLS-1$
	public static final String USING_SMART_GOTO_SOURCE = PREFIX
			+ "using_smart_goto_source"; // [html/Using_Smart_Goto_Source.htm] //$NON-NLS-1$
	public static final String USING_THE_DEBUGGER = PREFIX
			+ "using_the_debugger"; // [html/Debugging.htm] //$NON-NLS-1$
	public static final String LOCALLY_DEBUGGING_A_PHP_SCRIPT = PREFIX
			+ "locally_debugging_a_php_script"; // [html/Locally_Debugging_a_PHP_Script.htm] //$NON-NLS-1$
	public static final String DEBUGGING_A_PHP_WEB_PAGE = PREFIX
			+ "debugging_a_php_web_page"; // [html/Debugging_a_PHP_Web_Page.htm] //$NON-NLS-1$
	public static final String RUNNING_AND_ANALYZING_DEBUGGER_RESULTS = PREFIX
			+ "running_and_analyzing_debugger_results"; // [html/Analyzing_Debugger_Results.htm] //$NON-NLS-1$
	public static final String SETTING_UP_REMOTE_DEBUGGING = PREFIX
			+ "setting_up_remote_debugging"; // [html/Troubleshooting_Remote_Debugging.htm] //$NON-NLS-1$
	public static final String ADDING_A_SERVER_LOCATION_PATH_MAP = PREFIX
			+ "adding_a_server_location_path_map"; // [html/Adding_a_Server_Path_Map.htm] //$NON-NLS-1$
	public static final String ADDING_ELEMENTS_TO_A_PROJECT_S_INCLUDE_PATH = PREFIX
			+ "adding_elements_to_a_project_s_include_path"; // [html/Adding_Elements_to_a_Project_s_Include_Path.htm] //$NON-NLS-1$
	public static final String CONFIGURING_BUILD_PATHS = PREFIX
			+ "configuring_build_paths"; // [html/Configuring_Build_Paths.htm] //$NON-NLS-1$
	public static final String NEW_PROJECT_LAYOUT_PREFERENCES = PREFIX
			+ "new_project_layout_preferences"; // [html/New_Project_Layout_Preferences.htm] //$NON-NLS-1$
	public static final String PHP_BUILD_PATH_PROPERTIES = PREFIX
			+ "php_build_path_properties"; // [html/PHP_Build_Path_Properties.htm] //$NON-NLS-1$
	public static final String PHP_INCLUDE_PATH_PROPERTIES = PREFIX
			+ "php_include_path_properties"; // [html/PHP_Include_Path_Properties.htm] //$NON-NLS-1$
	public static final String CREATING_PHP_PROJECTS = PREFIX
			+ "creating_php_projects"; // [html/Creating_PHP_Projects.htm] //$NON-NLS-1$
	public static final String REFERENCE = PREFIX + "reference"; // [html/Reference.htm] //$NON-NLS-1$
	public static final String PHP_PERSPECTIVES_AND_VIEWS = PREFIX
			+ "php_perspectives_and_views"; // [html/PHP_Perspectives_and_Views.htm] //$NON-NLS-1$
	public static final String PHP_PERSPECTIVE = PREFIX + "php_perspective"; // [html/PHP_Perspective_Views.htm] //$NON-NLS-1$
	public static final String PHP_EXPLORER_VIEW = PREFIX + "php_explorer_view"; // [html/PHP_Explorer_view.htm] //$NON-NLS-1$
	public static final String PHP_FUNCTIONS_VIEW = PREFIX
			+ "php_functions_view"; // [html/PHP_Functions_View.htm] //$NON-NLS-1$
	public static final String PHP_PROJECT_OUTLINE_VIEW = PREFIX
			+ "php_project_outline_view"; // [html/Project_Outline_view.htm] //$NON-NLS-1$
	public static final String OUTLINE_VIEW = PREFIX + "outline_view"; // [html/PHP_Outline_VIew.htm] //$NON-NLS-1$
	public static final String PHP_DEBUG_PERSPECTIVE = PREFIX
			+ "php_debug_perspective"; // [html/PHP_Debug_Perspective.htm] //$NON-NLS-1$
	public static final String DEBUG_VIEW = PREFIX + "debug_view"; // [html/Debug_View.htm] //$NON-NLS-1$
	public static final String VARIABLES_VIEW = PREFIX + "variables_view"; // [html/Variables_View.htm] //$NON-NLS-1$
	public static final String BREAKPOINTS_VIEW = PREFIX + "breakpoints_view"; // [html/Breakpoints_View.htm] //$NON-NLS-1$
	public static final String PARAMETER_STACK_VIEW = PREFIX
			+ "parameter_stack_view"; // [html/Parameter_Stack.htm] //$NON-NLS-1$
	public static final String DEBUG_OUTPUT_VIEW = PREFIX + "debug_output_view"; // [html/Debug_Output_View.htm] //$NON-NLS-1$
	public static final String BROWSER_OUTPUT_VIEW = PREFIX
			+ "browser_output_view"; // [html/Browser_Output_View.htm] //$NON-NLS-1$
	public static final String PHP_PERSPECTIVE_MENUS = PREFIX
			+ "php_perspective_menus"; // [html/Menus.htm] //$NON-NLS-1$
	public static final String FILE = PREFIX + "file"; // [html/File.htm] //$NON-NLS-1$
	public static final String NEW = PREFIX + "new"; // [html/New.htm] //$NON-NLS-1$
	public static final String IMPORT = PREFIX + "import"; // [html/Import.htm] //$NON-NLS-1$
	public static final String EXPORT = PREFIX + "export"; // [html/Export.htm] //$NON-NLS-1$
	public static final String EDIT = PREFIX + "edit"; // [html/Edit.htm] //$NON-NLS-1$
	public static final String SOURCE = PREFIX + "source"; // [html/Source.htm] //$NON-NLS-1$
	public static final String REFACTOR = PREFIX + "refactor"; // [html/Refactor.htm] //$NON-NLS-1$
	public static final String NAVIGATE = PREFIX + "navigate"; // [html/Navigate.htm] //$NON-NLS-1$
	public static final String SEARCH = PREFIX + "search"; // [html/Search.htm] //$NON-NLS-1$
	public static final String PROJECT = PREFIX + "project"; // [html/Project.htm] //$NON-NLS-1$
	public static final String RUN = PREFIX + "run"; // [html/Run.htm] //$NON-NLS-1$
	public static final String WINDOW = PREFIX + "window"; // [html/Window.htm] //$NON-NLS-1$
	public static final String NAVIGATION = PREFIX + "navigation"; // [html/Navigation.htm] //$NON-NLS-1$
	public static final String HELP = PREFIX + "help"; // [html/Help.htm] //$NON-NLS-1$
	public static final String PHP_PERSPECTIVE_MAIN_TOOLBAR = PREFIX
			+ "php_perspective_main_toolbar"; // [html/PHP_Perspective_Main_Toolbar.htm] //$NON-NLS-1$
	public static final String PHP_PREFERENCES = PREFIX + "php_preferences"; // [html/Preferences.htm] //$NON-NLS-1$
	public static final String PHP_PREFERENCES_PAGE = PREFIX
			+ "php_preferences_page"; // [html/PHP.htm] //$NON-NLS-1$
	public static final String APPEARANCE_PREFERENCES = PREFIX
			+ "appearance_preferences"; // [html/Appearance.htm] //$NON-NLS-1$
	public static final String DEBUG_PREFERENCES = PREFIX + "debug_preferences"; // [html/Debug.htm] //$NON-NLS-1$
	public static final String INSTALLED_DEBUGGERS = PREFIX
			+ "installed_debuggers"; // [html/Installed_Debuggers.htm] //$NON-NLS-1$
	public static final String WORKBENCH_OPTIONS = PREFIX + "workbench_options"; // [html/Launching.htm] //$NON-NLS-1$
	public static final String EDITOR_PREFERENCES = PREFIX
			+ "editor_preferences"; // [html/Editor.htm] //$NON-NLS-1$
	public static final String CODE_ASSIST_PREFERENCES = PREFIX
			+ "code_assist_preferences"; // [html/Code_Assist.htm] //$NON-NLS-1$
	public static final String FOLDING_PREFERENCES = PREFIX
			+ "folding_preferences"; // [html/Folding.htm] //$NON-NLS-1$
	public static final String HOVERS_PREFERENCES = PREFIX
			+ "hovers_preferences"; // [html/Hovers.htm] //$NON-NLS-1$
	public static final String SYNTAX_COLORING_PREFERENCES = PREFIX
			+ "syntax_coloring_preferences"; // [html/Syntax_Coloring.htm] //$NON-NLS-1$
	public static final String TASK_TAGS_PREFERENCES = PREFIX
			+ "task_tags_preferences"; // [html/Task_Tags.htm] //$NON-NLS-1$
	public static final String TYPING_PREFERENCES = PREFIX
			+ "typing_preferences"; // [html/Typing.htm] //$NON-NLS-1$
	public static final String FORMATTER_PREFERENCES = PREFIX
			+ "formatter_preferences"; // [html/Formatter.htm] //$NON-NLS-1$
	public static final String PATH_VARIABLES_PREFERENCES = PREFIX
			+ "path_variables_preferences"; // [html/Path_Variables.htm] //$NON-NLS-1$
	public static final String PHP_EXECUTABLES_PREFERENCES = PREFIX
			+ "php_executables_preferences"; // [html/PHP_Executables.htm] //$NON-NLS-1$
	public static final String PHP_INTERPRETER_PREFERENCES = PREFIX
			+ "php_interpreter_preferences"; // [html/PHP_Interpreter.htm] //$NON-NLS-1$
	public static final String PHP_MANUAL_PREFERENCES = PREFIX
			+ "php_manual_preferences"; // [html/PHP_Manual.htm] //$NON-NLS-1$
	public static final String PHP_SERVERS_PREFERENCES = PREFIX
			+ "php_servers_preferences"; // [html/PHP_Servers.htm] //$NON-NLS-1$
	public static final String TEMPLATES_PREFERENCES = PREFIX
			+ "templates_preferences"; // [html/Templates.htm] //$NON-NLS-1$
	public static final String KEYMAP = PREFIX + "keymap"; // [html/Keymap.htm] //$NON-NLS-1$
	public static final String PHARPACKAGER_WIZARD_PAGE = PREFIX
			+ "phar_packager_wizard_page_context"; // [html/Keymap.htm] //$NON-NLS-1$

	public static final String PHPEXE_ENV_PREFERENCES = PREFIX
			+ "execution_environments_preferences"; // [html/Keymap.htm] //$NON-NLS-1$

	public static final String PHAR_FILE_IMPORT_WIZARD_PAGE = PREFIX
			+ "phar_file_import_wizard_page"; //$NON-NLS-1$
}